module Model exposing (Model, initialModel)

import Browser.Navigation as Nav
import Http
import Navigation
import Url exposing (Url)


type alias Model =
    { key : Nav.Key
    , apiHost : String
    , route : Navigation.Route
    , httpError : Maybe Http.Error
    }


initialModel : Nav.Key -> Navigation.Route -> Url -> Model
initialModel key route url =
    Model
        key
        ("//" ++ url.host ++ urlToPort url)
        route
        -- httpError
        Maybe.Nothing


urlToPort : Url -> String
urlToPort url =
    case url.port_ of
        Just p ->
            let
                isDebug =
                    p == 8000

                portToUse =
                    if isDebug then
                        8080

                    else
                        p
            in
            ":" ++ String.fromInt portToUse

        Nothing ->
            ""
